<?php

$webPlayer = get("https://webplayer.musicchoice.com");
preg_match_all("/(?:window\.mediaServicesSecret\ \=\ \\')(.*)(?:\\'\;)/", $webPlayer, $o1);
$clientSecret = $o1[1][0];

if(isset($clientSecret) && isset($_GET["id"])) {
    $id = $_GET["id"];
    $token = post("https://mediaservices.musicchoice.com/api/token", $clientSecret);
    $tokenJson = json_decode($token, true);
    $bearer = $tokenJson["access_token"];
    if(isset($bearer)) {
        $ch = get("https://mediaservices.musicchoice.com/api/media/streams/channels/".$id."/MCMediaApp/1.9", $bearer);
        $chJson = json_decode($ch, true);
        var_dump($chJson);
        header("Location: ".$chJson["PrimaryUrl"]);
    }
}

function get($url, $bearer=false) {
    $headers = [];
    $headers[] = "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36";
    if($bearer != false) {
        $headers[] = "Authorization: bearer $bearer";
    }
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    $data = curl_exec($curl);
    curl_close($curl);
    return $data;
}

function post($url, $secret) {
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, [
        "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.87 Safari/537.36"
    ]);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, "grant_type=client_credentials&client_id=MCMediaApp&client_secret=".urlencode($secret));
    $data = curl_exec($curl);
    curl_close($curl);
    return $data;
}

?>